      SUBROUTINE  OUTDCL (LBR)
      INTEGER A1NAME(6), ASFARG, ASFFCN, ASGOTO, BLANK, COMNAM, EXTFCN, 
     X     EXTNAM, EXTSUB, IARG, IGATT1, INDEX, ITRFCN, JBR, JBR2,JT, 
     X     LABEL, LBR, LINK, LSTPOS, MOD, NLSNAM, STAR, SYMHD, SYMHD2, 
     X     TCCOMM, TCCPLX, TCDP, TCEXT, TCHOLL, TCINT, TCLOG, TCNLST, 
     X     TCREAL, TCREFS, TCSETS, TCUNRF, TYPE, TYPORD(6), UNSET, 
     X     USAGE, USE, VARBLE, VARTYP
      LOGICAL ANYUSE, ARGVAR, COMVAR, CONTIN, DUMP, EXPDCL, EQVVAR, 
     X     HEADER, OUTDIM, SETS, SF3VAR, TAB, UNREF, VARDIM
C
      INTEGER LDSA, PDSA, DSA
      COMMON /CTABL/ LDSA, PDSA, DSA(5000)
C
      INTEGER LHASH, HASH
      COMMON /CHASH/ LHASH, HASH(401)
C
      LOGICAL SW
      COMMON /SWS/ SW(10)
C
      INTEGER LSTACK, STACK
      COMMON /CEXPRS/ LSTACK, STACK(620)
C
      INTEGER DCLFIL
      LOGICAL DCLOUT
      COMMON /DCLCB/ DCLFIL,DCLOUT
C
      DATA STAR/1H*/
      DATA BLANK/1H /
C
C     TYPORD(*) DEFINES THE ORDER IN WHICH TYPE DECLARATIONS WILL BE
C     OUTPUT.  TYPORD(K) IS THE INTERNAL TYPE CODE OF THE K-TH
C     DECLARATION GROUP.
C
      DATA TYPORD(1), TYPORD(2), TYPORD(3), TYPORD(4), TYPORD(5),
     X     TYPORD(6) / 0, 3, 5, 2, 4, 1 /
C
C     SYMBOLIC LOGICAL FLAGS.
C
      DATA DUMP/.TRUE./, OUTDIM/.TRUE./, CONTIN/.TRUE./
C
C     SYMBOLIC USAGE CODES.
C
      DATA UNSET / 0/, ASFARG/ 1/, ASFFCN/ 2/, EXTFCN/ 5/, EXTSUB/6/
      DATA COMNAM/ 7/, ASGOTO/ 8/, LABEL / 8/, VARBLE/10/, EXTNAM/13/
      DATA ITRFCN/14/, NLSNAM/15/
C
C     DECLARATION TYPE CODES FOR OUTTYP.
C
      DATA TCINT / 2/, TCREAL/ 1/, TCDP / 0/, TCLOG / 4/, TCCPLX/ 3/
      DATA TCHOLL/ 5/, TCCOMM/ 6/, TCEXT/ 7/, TCREFS/ 8/, TCSETS/ 9/
      DATA TCUNRF/10/, TCNLST/11/
C
      ARGVAR(IARG) = (IGATT1(IARG,4) .EQ. 1)
      COMVAR(IARG) = (IGATT1(IARG,2) .EQ. 1)
      EQVVAR(IARG) = (IGATT1(IARG,3) .EQ. 1)
      EXPDCL(IARG) = (IGATT1(IARG,1)/8 .EQ. 1)
      SETS(IARG) = (IGATT1(IARG,5) .EQ. 1)
      USAGE(IARG) = IGATT1(IARG,8)
      VARDIM(IARG) = (IGATT1(IARG,6) .EQ. 1)
      VARTYP(IARG) = MOD(IGATT1(IARG,1),8)
C
C     QUIT IMMEDIATELY IF NO DECLARATION FILE IS AVAILABLE.
C
      IF (DCLFIL .EQ. 0) GO TO 500
C-----------------------------------------------------------------------
C
C     VARIABLES ARE OUTPUT AT TAB COLUMNS IF SELECTED BY
C     INSTALLATION OPTION, SW(6).
C
      TAB = SW(6)
C-----------------------------------------------------------------------
C
C     OUTPUT A COMMENT LIST OF THE EXTERNAL REFERENCES MADE IN THIS
C     PROGRAM UNIT.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 10 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (.NOT.((USE .EQ. EXTFCN) .OR. (USE .EQ. EXTSUB) .OR.
     X          (USE.EQ. ITRFCN) .OR. (USE .EQ. COMNAM))) GO TO 10
           IF (UNREF(SYMHD)) GO TO 10
           IF (HEADER) WRITE (DCLFIL,99991)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCREFS,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
   10      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 20
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
   20 CONTINUE
C-----------------------------------------------------------------------
C
C     OUTPUT A COMMENT LIST OF FUNCTIONS AND SUBROUTINES WHICH ARE
C     UNREFERENCED IN EXECUTABLE STATEMENTS.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 30 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (.NOT.((USE .EQ. EXTFCN) .OR. (USE .EQ. EXTNAM))) GO TO 30
           IF (.NOT.UNREF(SYMHD)) GO TO 30
           IF (HEADER) WRITE (DCLFIL,99999)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
   30      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 40
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
C
C     OUTPUT TYPE DECLARATIONS FOR THE EXTERNAL FUNCTIONS.  THESE
C     INCLUDE USER-DEFINED FUNCTIONS AND THE FORTRAN BASIC
C     EXTERNAL FUNCTIONS.  IN ADDITION, FUNCTIONS MARKED AS
C     EXTERNAL AND EXPLICITLY TYPED ARE ALSO INCLUDED IN THE TYPE
C     DECLARATIONS.
C
   40      DO 60 JT = 1,6
           TYPE = TYPORD(JT)
           LSTPOS = 0
                DO 50 JBR = 1,LBR
                SYMHD = HASH(JBR)
                USE = USAGE(SYMHD)
                IF (.NOT.((USE .EQ. EXTFCN) .OR. ((USE .EQ. EXTNAM) 
     X               .AND. EXPDCL(SYMHD)))) GO TO 50
                IF (VARTYP(SYMHD) .NE. TYPE) GO TO 50
                IF (HEADER) WRITE (DCLFIL,99999)
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X               .NOT.DUMP,LSTPOS)
   50           CONTINUE
           IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,
     X          DUMP,LSTPOS)
   60      CONTINUE
C
C     OUTPUT PRIVATE FUNCTION EXTERNAL DECLARATIONS.  IN
C     ADDITION, NAMES WHICH ARE BOTH DUMMY ARGUMENTS AND
C     SUBROUTINE/FUNCTION NAMES ARE INCLUDED IN THE EXTERNAL
C     DECLARATION.
C
      LSTPOS = 0
           DO 70 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (.NOT.((USE .EQ. EXTNAM) .OR. (ARGVAR(SYMHD) .AND. ((USE
     X          .EQ. EXTFCN) .OR. (USE .EQ. EXTSUB))))) GO TO 70
           IF (HEADER) WRITE (DCLFIL,99999)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCEXT,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
   70      CONTINUE
      IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,
     X     LSTPOS)
C-----------------------------------------------------------------------
C
C     OUTPUT COMMENT LISTS OF UNREFERENCED INTRINSIC FUNCTIONS.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 80 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. ITRFCN) GO TO 80
           IF (.NOT.UNREF(SYMHD)) GO TO 80
           IF (HEADER) WRITE (DCLFIL,99995)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
   80      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 90
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
C
C     OUTPUT DECLARATIONS FOR INTRINSIC FUNCTIONS, ORDERED ACCORDING
C     TO TYPORD(*).
C
   90      DO 110 JT = 1,6
           TYPE = TYPORD(JT)
           LSTPOS = 0
                DO 100 JBR = 1,LBR
                SYMHD = HASH(JBR)
                USE = USAGE(SYMHD)
                IF (USE .NE. ITRFCN) GO TO 100
                IF (VARTYP(SYMHD) .NE. TYPE) GO TO 100
                IF (HEADER) WRITE (DCLFIL,99995)
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X               .NOT.DUMP,LSTPOS)
  100           CONTINUE
           IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,
     X          DUMP,LSTPOS)
  110      CONTINUE
C-----------------------------------------------------------------------
C
C     OUTPUT COMMENT LISTS OF STATEMENT FUNCTIONS WHICH ARE
C     UNREFERENCED IN EXECUTABLE STATEMENTS.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 120 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. ASFFCN) GO TO 120
           IF (.NOT.UNREF(SYMHD)) GO TO 120
           IF (HEADER) WRITE (DCLFIL,99994)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
  120      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 130
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
C
C     OUTPUT DECLARATIONS FOR STATEMENT FUNCTIONS, ORDERED ACCORDING
C     TO TYPORD(*).
C
  130      DO 150 JT = 1,6
           TYPE = TYPORD(JT)
           LSTPOS = 0
                DO 140 JBR = 1,LBR
                SYMHD = HASH(JBR)
                USE = USAGE(SYMHD)
                IF (USE .NE. ASFFCN) GO TO 140
                IF (VARTYP(SYMHD) .NE. TYPE) GO TO 140
                IF (HEADER) WRITE (DCLFIL,99994)
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X               .NOT.DUMP,LSTPOS)
  140           CONTINUE
           IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,
     X          DUMP,LSTPOS)
  150      CONTINUE
C-----------------------------------------------------------------------
C
C     OUTPUT **INTEGER** DECLARATIONS FOR VARIABLE DIMENSION VARIABLES.
C     THERE IS NO NEED TO CHECK FOR OTHER DATA TYPES THAN INTEGER.
C     THESE ARE CONSIDERED REFERENCED, EVEN IF THEY DO NOT OCCUR IN
C     EXECUTABLE STATEMENTS.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 160 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. VARBLE) GO TO 160
           IF (COMVAR(SYMHD)) GO TO 160
           IF (.NOT.VARDIM(SYMHD)) GO TO 160
           IF (HEADER) WRITE (DCLFIL,99998)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCINT,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
  160      CONTINUE
      IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,
     X     LSTPOS)
C-----------------------------------------------------------------------
C
C     OUTPUT **INTEGER** DECLARATIONS FOR NON-COMMON ASSIGNED GO TO
C     VARIABLES.  THESE ARE LISTED SEPARATELY BECAUSE OF THEIR HEAVY
C     USE BY FORTRAN PREPROCESSORS.  THESE HAVE BEEN NECESSARILY
C     REFERENCED IN ASSIGNED GO TO STATEMENTS, SO NO COMMENT LIST
C     OF UNREFERENCED VARIABLES IS REQUIRED.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 170 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. ASGOTO) GO TO 170
           IF (COMVAR(SYMHD)) GO TO 170
           IF (SF3VAR(SYMHD)) GO TO 170
           IF (HEADER) WRITE (DCLFIL,99993)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCINT,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,OUTDIM,.NOT.CONTIN,.NOT.DUMP,LSTPOS)
  170      CONTINUE
      IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,
     X     LSTPOS)
C-----------------------------------------------------------------------
C
C     OUTPUT A COMMENT LIST OF UNREFERENCED NON-COMMON HOLLERITH
C     VARIABLES.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 180 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .EQ. UNSET) GO TO 180
           IF (VARTYP(SYMHD) .NE. TCHOLL) GO TO 180
           IF (COMVAR(SYMHD)) GO TO 180
           IF (SETS(SYMHD)) GO TO 180
           IF (.NOT.UNREF(SYMHD)) GO TO 180
           IF (HEADER) WRITE (DCLFIL,99990)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
  180      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 190
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
C
C     OUTPUT NON-COMMON HOLLERITH VARIABLE DECLARATIONS.
C
  190 LSTPOS = 0
           DO 200 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .EQ. UNSET) GO TO 200
           IF (VARTYP(SYMHD) .NE. TCHOLL) GO TO 200
           IF (COMVAR(SYMHD)) GO TO 200
           IF (HEADER) WRITE (DCLFIL,99990)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCHOLL,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,OUTDIM,.NOT.CONTIN,.NOT.DUMP,LSTPOS)
  200      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 210
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
  210 CONTINUE
C-----------------------------------------------------------------------
C
C     OUTPUT A COMMENT LIST OF NON-COMMON VARIABLES WHICH ARE NOT
C     REFERENCED IN THE PROGRAM UNIT IN EXECUTABLE STATEMENTS.
C
      HEADER = .TRUE.
      LSTPOS = 0
           DO 220 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (.NOT.((USE .EQ. ASFARG) .OR. (USE .EQ. ASGOTO) .OR.
     X          (USE.EQ. VARBLE))) GO TO 220
           IF (COMVAR(SYMHD)) GO TO 220
           IF (VARDIM(SYMHD)) GO TO 220
           IF (VARTYP(SYMHD) .EQ. TCHOLL) GO TO 220
           IF (SETS(SYMHD)) GO TO 220
           IF (.NOT.UNREF(SYMHD)) GO TO 220
           IF (HEADER) WRITE (DCLFIL,99997)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
  220      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 230
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
  230 CONTINUE
C
C     OUTPUT COMMENTS WITH NON-COMMON VARIABLES WHICH ARE SET IN THE
C     PROGRAM UNIT.
C
      LSTPOS = 0
           DO 240 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (.NOT.((USE .EQ. ASFARG) .OR. (USE.EQ. VARBLE))) GO TO 240
           IF (COMVAR(SYMHD)) GO TO 240
           IF (VARDIM(SYMHD)) GO TO 240
           IF (.NOT.SETS(SYMHD)) GO TO 240
           IF (VARTYP(SYMHD) .EQ. TCHOLL) GO TO 240
           IF (SF3VAR(SYMHD)) GO TO 240
           IF (HEADER) WRITE (DCLFIL,99997)
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCSETS,LSTPOS)
           CALL OUTTOK (SYMHD,TAB,.NOT.OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
  240      CONTINUE
      IF (LSTPOS .LE. 0) GO TO 250
      CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
      WRITE (DCLFIL,99992)
  250 CONTINUE
C
C     OUTPUT DECLARATIONS FOR NON-COMMON VARIABLES, ORDERED ACCORDING
C     TO TYPORD(*).
C
           DO 270 JT = 1,6
           TYPE = TYPORD(JT)
           IF (TYPE .EQ. TCHOLL) GO TO 270
           LSTPOS = 0
                DO 260 JBR = 1,LBR
                SYMHD = HASH(JBR)
                USE = USAGE(SYMHD)
                IF (.NOT.((USE .EQ. ASFARG) .OR. (USE .EQ. VARBLE))) GO
     X               TO 260
                IF (VARTYP(SYMHD) .NE. TYPE) GO TO 260
                IF (COMVAR(SYMHD)) GO TO 260
                IF (VARDIM(SYMHD)) GO TO 260
                IF (SF3VAR(SYMHD)) GO TO 260
                IF (HEADER) WRITE (DCLFIL,99997)
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                CALL OUTTOK (SYMHD,TAB,OUTDIM,.NOT.CONTIN,.NOT.DUMP,
     X               LSTPOS)
  260           CONTINUE
           IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,OUTDIM,.NOT.CONTIN,
     X          DUMP,LSTPOS)
  270      CONTINUE
C-----------------------------------------------------------------------
C
C     PROCESS COMMON BLOCKS IN ALPHABETICAL ORDER.
C
           DO 460 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. COMNAM) GO TO 460
C
C          OUTPUT COMMENTS WITH COMMON VARIABLES UNREFERENCED IN
C          EXECUTABLE STATEMENTS IN THE PROGRAM UNIT.  BLANK COMMON
C          IS STORED IN THE SYMBOL TABLE WITH THE NAME '*COM', AND
C          THEREFORE REQUIRES SPECIAL HANDLING.  BECAUSE
C          VARIABLES WHICH ARE EQUIVALENCED TO VARIABLES IN
C          COMMON ARE NOT STORED IN THE COMMON CHAIN, IT IS
C          NECESSARY TO SCAN THE ENTIRE SYMBOL TABLE TO FIND ALL
C          VARIABLES WHICH BELONG TO THE CURRENT COMMON BLOCK.
C          TYPE DECLARATIONS FOR EQUIVALENCED VARIABLES ARE
C          OUTPUT SEPARATELY FROM THOSE EXPLICITLY IN COMMON,
C          SINCE DIMENSIONS OF THE LATTER MAY APPEAR ON EITHER
C          THE TYPE STATEMENT OR THE COMMON STATEMENT, DEPENDING
C          UPON THE INSTALLATION SWITCH, SW(7).  BECAUSE 
C          UNUSED COMMON BLOCKS MAY BE UNNECESSARY (EXCEPT FOR
C          OVERLAY PURPOSES AND PFORT RULES), WE KEEP TRACK OF
C          WHETHER ANY OF THE COMMON VARIABLES, OR ONES
C          EQUIVALENCED TO THEM, ARE USED.  IF NONE ARE, A
C          COMMENT LINE WARNING OF THE UNUSED COMMON IS OUTPUT. 
C
           ANYUSE = .FALSE.
           CALL S5UNPK (DSA(SYMHD+4),A1NAME,6)
           IF (A1NAME(1) .NE. STAR) GO TO 280
           A1NAME(1) = BLANK
           A1NAME(2) = BLANK
           A1NAME(3) = BLANK
           A1NAME(4) = BLANK
           A1NAME(5) = BLANK
           A1NAME(6) = BLANK
  280      HEADER = .TRUE.
           LSTPOS = 0
                DO 290 JBR2 = 1,LBR
                SYMHD2 = HASH(JBR2)
                USE = USAGE(SYMHD2)
                IF (USE .NE. VARBLE) GO TO 290
                IF (.NOT.COMVAR(SYMHD2)) GO TO 290
                INDEX = DSA(SYMHD2+2)
                IF (SYMHD .NE. DSA(INDEX+1)) GO TO 290
                IF (SETS(SYMHD2)) GO TO 290
                IF (UNREF(SYMHD2)) GO TO 285
                ANYUSE = .TRUE.
                GO TO 290
  285           IF (HEADER) WRITE (DCLFIL,99996) A1NAME
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TCUNRF,LSTPOS)
                CALL OUTTOK (SYMHD2,TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X               .NOT.DUMP,LSTPOS)
  290           CONTINUE
           IF (LSTPOS .LE. 0) GO TO 320
           CALL OUTTOK (INDEX,TAB,.NOT.OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
           WRITE (DCLFIL,99992)
C
C          OUTPUT COMMENTS WITH COMMON VARIABLES SET IN THE PROGRAM
C          UNIT.
C
  320      LSTPOS = 0
                DO 330 JBR2 = 1,LBR
                SYMHD2 = HASH(JBR2)
                USE = USAGE(SYMHD2)
                IF (USE .NE. VARBLE) GO TO 330
                IF (.NOT.COMVAR(SYMHD2)) GO TO 330
                INDEX = DSA(SYMHD2+2)
                IF (SYMHD .NE. DSA(INDEX+1)) GO TO 330
                IF (.NOT.SETS(SYMHD2)) GO TO 330
                ANYUSE = .TRUE.
                IF (HEADER) WRITE (DCLFIL,99996) A1NAME
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TCSETS,LSTPOS)
                CALL OUTTOK (SYMHD2,TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X               .NOT.DUMP,LSTPOS)
  330           CONTINUE
           IF (LSTPOS .LE. 0) GO TO 360
           CALL OUTTOK (INDEX,TAB,.NOT.OUTDIM,.NOT.CONTIN,DUMP,LSTPOS)
           WRITE (DCLFIL,99992)
C
C          OUTPUT TYPE DECLARATIONS FOR THE VARIABLES IN THE CURRENT
C          COMMON BLOCK, ORDERING ACCORDING TO TYPORD(*).  VARIABLES
C          USED AS DIMENSIONS ARE OUTPUT FIRST IN SEPARATE
C          **INTEGER** DECLARATION STATEMENTS.  DIMENSIONS ARE
C          OUTPUT ON THESE STATEMENTS IF THE INSTALLATION OPTION,
C          SW(7), IS .TRUE..  OTHERWISE, THEY ARE OUTPUT ON THE
C          COMMON STATEMENT WHICH FOLLOWS THE TYPE DECLARATIONS.
C
  360      LSTPOS = 0
           LINK = DSA(SYMHD+2)
  370      IF (LINK .LE. 0) GO TO 390
           INDEX = DSA(LINK)
           LINK = DSA(LINK+1)
           IF (.NOT.VARDIM(INDEX)) GO TO 380
           IF (HEADER) WRITE (DCLFIL,99996) A1NAME
           HEADER = .FALSE.
           IF (LSTPOS .EQ. 0) CALL OUTTYP (TCINT,LSTPOS)
           CALL OUTTOK (INDEX,TAB,SW(7),.NOT.CONTIN,.NOT.DUMP,LSTPOS)
  380      GO TO 370
  390      IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,SW(7),.NOT.CONTIN,DUMP,
     X          LSTPOS)
           LSTPOS = 0
                DO 430 JT = 1,6
                TYPE = TYPORD(JT)
                LINK = DSA(SYMHD+2)
  400           IF (LINK .LE. 0) GO TO 420
                INDEX = DSA(LINK)
                LINK = DSA(LINK+1)
                IF (VARTYP(INDEX) .NE. TYPE) GO TO 410
                IF (VARDIM(INDEX)) GO TO 410
                IF (HEADER) WRITE (DCLFIL,99996) A1NAME
                HEADER = .FALSE.
                IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                CALL OUTTOK (INDEX,TAB,SW(7),.NOT.CONTIN,.NOT.DUMP,
     X               LSTPOS)
  410           GO TO 400
  420           IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,SW(7),.NOT.CONTIN,
     X               DUMP,LSTPOS)
C
C               NOW SCAN THE SYMBOL TABLE FOR VARIABLES WHICH ARE
C               EQUIVALENCED TO OTHERS IN THIS COMMON BLOCK, AND
C               OUTPUT TYPE DECLARATIONS FOR THEM.
C
                     DO 426 JBR2 = 1,LBR
                     SYMHD2 = HASH(JBR2)
                     USE = USAGE(SYMHD2)
                     IF (USE .NE. VARBLE) GO TO 426
                     IF (VARTYP(SYMHD2) .NE. TYPE) GO TO 426
                     IF (.NOT.COMVAR(SYMHD2)) GO TO 426
                     IF (.NOT.EQVVAR(SYMHD2)) GO TO 426
                     INDEX = DSA(SYMHD2+2)
                     IF (SYMHD .NE. DSA(INDEX+1)) GO TO 426
                     LINK = DSA(SYMHD+2)
  422                IF (LINK .LE. 0) GO TO 424                  
                     INDEX = DSA(LINK)
                     LINK = DSA(LINK+1)
                     IF (INDEX .EQ. SYMHD2) GO TO 426
                     GO TO 422
  424                IF (HEADER) WRITE (DCLFIL,99996) A1NAME
                     HEADER = .FALSE.
                     IF (SETS(SYMHD2) .OR. (.NOT.UNREF(SYMHD2))) ANYUSE 
     X                    = .TRUE.
                     IF (LSTPOS .EQ. 0) CALL OUTTYP (TYPE,LSTPOS)
                     CALL OUTTOK (SYMHD2,TAB,.TRUE.,.NOT.CONTIN,
     X                    .NOT.DUMP,LSTPOS)
  426                CONTINUE
                IF (LSTPOS .GT. 0) CALL OUTTOK (0,TAB,.TRUE.,
     X               .NOT.CONTIN,DUMP,LSTPOS)
  430           CONTINUE
           IF (.NOT.ANYUSE) WRITE (DCLFIL,99988) A1NAME
C
C          OUTPUT THE COMMON STATEMENT ITSELF.
C
           LSTPOS = 0
           CALL OUTTYP (TCCOMM,LSTPOS)
           CALL OUTTOK (SYMHD,.NOT.TAB,.NOT.OUTDIM,.NOT.CONTIN,
     X          .NOT.DUMP,LSTPOS)
           LINK = DSA(SYMHD+2)
  440      IF (LINK .LE. 0) GO TO 450
           INDEX = DSA(LINK)
           LINK = DSA(LINK+1)
           CALL OUTTOK (INDEX,TAB,.NOT.SW(7),.NOT.CONTIN,.NOT.DUMP,
     X          LSTPOS)
           GO TO 440
  450      IF (LSTPOS .LE. 0) GO TO 460
           CALL OUTTOK (0,TAB,.NOT.SW(7),.NOT.CONTIN,DUMP,LSTPOS)
           WRITE (DCLFIL,99992)
  460      CONTINUE
C-----------------------------------------------------------------------
C
C     PROCESS NAMELIST BLOCKS IN ALPHABETICAL ORDER.  THE NAMELIST
C     VARIABLES IN EACH BLOCK HAVE BEEN STORED IN A LINKED LIST IN
C     PFORT LEXICAL ORDER.
C
      HEADER = .TRUE.
           DO 490 JBR = 1,LBR
           SYMHD = HASH(JBR)
           USE = USAGE(SYMHD)
           IF (USE .NE. NLSNAM) GO TO 490
           IF (HEADER) WRITE (DCLFIL,99989)
           HEADER = .FALSE.
           LSTPOS = 0
           CALL OUTTYP (TCNLST,LSTPOS)
           CALL OUTTOK (SYMHD,.NOT.TAB,.NOT.OUTDIM,CONTIN,.NOT.DUMP,
     X          LSTPOS)
           LINK = DSA(SYMHD+2)
  470      IF (LINK .LE. 0) GO TO 480
           INDEX = DSA(LINK)
           LINK = DSA(LINK+1)
           CALL OUTTOK (INDEX,TAB,.NOT.OUTDIM,CONTIN,.NOT.DUMP,LSTPOS)
           GO TO 470
  480      IF (LSTPOS .LE. 0) GO TO 490
           CALL OUTTOK (0,TAB,.NOT.OUTDIM,CONTIN,DUMP,LSTPOS)
           WRITE (DCLFIL,99992)
  490      CONTINUE
C
  500 RETURN
C
99988 FORMAT (1HC/32HC     *** UNUSED COMMON BLOCK / ,6A1,6H / ***/1HC)
99989 FORMAT (1HC,35(2H- )/1HC/
     X     21HC     NAMELIST BLOCKS/
     X     1HC)
99990 FORMAT (1HC,35(2H- )/1HC/
     X     32HC     HOLLERITH STRING VARIABLES/1HC)
99991 FORMAT (1HC,35(2H- )/1HC/
     X     54HC     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)/
     X     1HC)
99992 FORMAT (1HC)
99993 FORMAT (1HC,35(2H- )/1HC/
     X     30HC     ASSIGNED GO TO VARIABLES/1HC)
99994 FORMAT (1HC,35(2H- )/1HC/
     X     25HC     STATEMENT FUNCTIONS/1HC)
99995 FORMAT (1HC,35(2H- )/1HC/
     X     25HC     INTRINSIC FUNCTIONS/1HC)
99996 FORMAT (1HC,35(2H- )/1HC/
     X     21HC     COMMON BLOCK / ,6A1,2H //1HC)
99997 FORMAT (1HC,35(2H- )/1HC/
     X     26HC     NON-COMMON VARIABLES/1HC)
99998 FORMAT (1HC,35(2H- )/1HC/
     X     33HC     RUNTIME DIMENSION VARIABLES/1HC)
99999 FORMAT (1HC,35(2H- )/1HC/
     X     40HC     EXTERNAL FUNCTIONS AND SUBROUTINES/1HC)
      END
