      SUBROUTINE  OUTTYP (TYPE,LSTPOS)
C
C     OUTPUT A TYPE DECLARATION TO STACK(*) IN COMMON.  'TYPE' IS A
C     CODE FOR SELECTING THE REQUIRED TYPE DECLARATION (0 = DOUBLE
C     PRECISION, 1 = REAL, 2 = INTEGER, 3 = COMPLEX, 4 = LOGICAL, 5
C     = HOLLERITH, 6 = COMMON, 7 = EXTERNAL, 8 = REFS(COMMENT), 9 =
C     SETS(COMMENT), 10 = UNREFERENCED(COMMENT), 11 = NAMELIST).  ON
C     RETURN, LSTPOS IS SET TO THE LAST POSITION USED IN STACK(*).
C     (28-AUG-82)
      INTEGER TYPE,LSTPOS,TABCOL(2),BLANK,KGO
C
      INTEGER LSTACK,STACK
      COMMON /CEXPRS/ LSTACK, STACK(620)
C
      INTEGER DCLFIL
      LOGICAL DCLOUT
      COMMON /DCLCB/ DCLFIL,DCLOUT
C
C     TAB POSITIONS (ALSO DEFINED IN ROUTINE 'OUTTOK').  TABCOL(1)
C     IS THE COLUMN IN WHICH A COMMON NAME STARTS.  TABCOL(2)...
C     ARE THE COLUMNS AT WHICH VARIABLES IN THE LISTS BEGIN.
C     ONLY TABCOL(1) AND TABCOL(2) ARE REQUIRED HERE.
C
      DATA TABCOL(1), TABCOL(2) /16, 27/
      DATA BLANK /1H /
C
C     BLANK 73 COLUMNS (THE LAST IS USED FOR LOOKAHEAD IN OUTTOK).
C
      DO 10 LSTPOS = 1,73
           STACK(LSTPOS) = BLANK
   10 CONTINUE
C
C     COPY IN A TYPE KEYWORD TEMPLATE.
C
      KGO = TYPE + 1
      GO TO (20,30,40,50,60,70,80,90,100,110,120,130),KGO
   20 CALL S5UNPK (16HDOUBLE PRECISION,STACK(7),16)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   30 CALL S5UNPK (4HREAL,STACK(7),4)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   40 CALL S5UNPK (7HINTEGER,STACK(7),7)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   50 CALL S5UNPK (7HCOMPLEX,STACK(7),7)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   60 CALL S5UNPK (7HLOGICAL,STACK(7),7)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   70 CALL S5UNPK (7HINTEGER,STACK(7),7)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
   80 CALL S5UNPK (17HCOMMON /        /,STACK(7),17)
      LSTPOS = TABCOL(1) - 1
      GO TO 140
   90 CALL S5UNPK (8HEXTERNAL,STACK(7),8)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
  100 CALL S5UNPK (19HC     EXTERNAL REFS,STACK(1),19)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
  110 CALL S5UNPK (10HC     SETS,STACK(1),10)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
  120 CALL S5UNPK (12HC     UNUSED,STACK(1),12)
      LSTPOS = TABCOL(2) - 1
      GO TO 140
  130 CALL S5UNPK (25H      NAMELIST /        /,STACK(1),25)
      LSTPOS = 17
      GO TO 140
C
  140 RETURN
C
      END
